/* ********************************************************************** */
/* *   sockcl02 : Sample client program using SQATT.                    * */
/* ********************************************************************** */

#include   <stdio.h>
#include   <string.h>
#include   <stdlib.h>

#include   <arpa/inet.h>

#include   <sqatt.h>
#include   <sqatt_func.h>

int     main( argc , argv )
int     argc ;
char   *argv[] ;
{
     int     rslt ;
     int     sd_len  ;
     int     rp_len  ;
     int     rp_size ;
     int     data_size ;
     char    sd_data[ 4096 ] ;
     char    rp_data[ 4096 ] ;
     SQATT   sqatt ;

     if( argc != 2 )
     {
          printf( "Invalid parameters.\n" ) ;
          exit( -1 ) ;
     }

     rslt = sqatt_copen( &sqatt , 3256 , SQATT_2_WAY_QUEUE , 21 ) ;

     data_size = sizeof( sd_data  ) ;
     sd_len    = strlen( argv[ 1 ]) ;

     memset( sd_data , 0x00      , data_size ) ;
     memcpy( sd_data , argv[ 1 ] , sd_len    ) ;

     rp_size = sizeof( rp_data ) ;
     memset( rp_data , 0x00 , rp_size ) ;

     printf( "sd_len  = %5d\n" , sd_len  ) ;
     printf( "sd_data = %s\n"  , sd_data ) ;

     rslt = sqatt_call( &sqatt , sd_len , sd_data ,
                        rp_size , &rp_len , rp_data ) ;

     printf( "rp_len  = %5d\n" , rp_len  ) ;
     printf( "rp_data = %s\n"  , rp_data ) ;
     printf( "rslt    = %5d\n" , rslt    ) ;

     sqatt_close( &sqatt ) ; 
}

