/* ********************************************************************** */
/* *  socksv02: Sample server program using SQATT.                      * */
/* ********************************************************************** */

#include   <stdio.h>
#include   <string.h>
#include   <stdlib.h>
#include   <stdarg.h>

#include   <arpa/inet.h>

#include   <sqatt.h>
#include   <sqatt_func.h>

char   *sq_reverse( char* ) ;

int     main()
{
     int     rslt ;
     int     rv_size ;
     int     rp_size ;
     int     rv_len  ;
     int     rp_len  ;
     char    rv_data[ 256 ] ;
     char    rp_data[ 256 ] ;
     SQATT   sqatt ;

     sqatt_sopen( &sqatt , 3256 , SQATT_2_WAY_QUEUE ) ;

     while( 1 )
     {
          rslt = sqatt_wait( &sqatt ) ;

          if( rslt == SQATT_RECEIVED )
          {
               rv_size = sizeof( rv_data ) ;
               memset( rv_data , 0x00 , rv_size ) ;

               rslt = sqatt_recv( &sqatt , rv_size , &rv_len , rv_data ) ;

               printf( "sqatt_recv() ----------\n" ) ;
               printf( "rslt:%3d , rv_len:%5d , rv_data: %s\n" ,
                        rslt , rv_len , rv_data ) ;

               rp_size = sizeof( rp_data ) ;
               memset( rp_data , 0x00 , rp_size ) ;
               strcpy( rp_data , sq_reverse( rv_data )) ;
               rp_len = strlen( rp_data ) ;

               printf( "sqatt_reply() ----------\n" ) ;
               printf( "rp_len:%5d , rp_data: %s\n" , rp_len , rp_data ) ;
               rslt = sqatt_reply( &sqatt , rp_len , rp_data ) ;
               printf( "rslt:%3d\n" , rslt ) ;
          }
          else
          {
               printf( "sqatt_wait() rslt:%3d" , rslt ) ;
               break ;
          }
     }
}

char   *sq_reverse( str )
char   *str ;
{
     int     i ;
     int     j ;
     int     ilen ;

     static  char    wstr[ 4096 ] ;

     memset( wstr , 0x00 , sizeof( wstr )) ;

     ilen = strlen( str ) ;

     for( i = ilen - 1 , j = 0 ; i >= 0 ; --i , ++j )
     {
          wstr[ j ] = str[ i ] ;
     }

     return( wstr ) ;
}

