/* ********************************************************************** */
/* *   socksv02_uev : Sample server program using SQATT.                * */
/* ********************************************************************** */

#include   <stdio.h>
#include   <string.h>
#include   <stdlib.h>
#include   <stdarg.h>

#include   <sys/types.h>
#include   <sys/socket.h>
#include   <sys/time.h>
#include   <sys/ioctl.h>
#include   <netinet/in.h>
#include   <arpa/inet.h>

#include   <sys/un.h>
#include   <unistd.h>

#include   <sqatt.h>
#include   <sqatt_func.h>

int     main()
{
     int     svfd  ;
     int     wsvfd ;
     int     clfd  ;
     int     svlen ;
     int     cllen ;
     int     rp_len  ;
     int     rp_size ;
     int     buf_size  ;
     int     data_size ;
     int     rslt ;

     char    ch ;
     char    data_buf[ 4096 ] ;
     char    rp_data [ 4096 ] ;

     struct  sockaddr_un   sv_addr ;
     struct  sockaddr_un   cl_addr ;

     SQATT   sqatt ;

     unlink( "server_socket" ) ;
     svfd = socket( AF_UNIX , SOCK_STREAM , 0 ) ;
     sv_addr.sun_family = AF_UNIX ;
     strcpy( sv_addr.sun_path , "server_socket" ) ;
     svlen = sizeof( sv_addr ) ;

     bind  ( svfd , ( struct sockaddr *)&sv_addr , svlen ) ;
     listen( svfd , 5 ) ;

     sqatt_sopen( &sqatt , 3256 , SQATT_2_WAY_QUEUE ) ;
     sqatt_add_usrfd( &sqatt , svfd ) ;

     while( 1 )
     {
          printf( "sqatt_wait start ...\n" ) ;
          rslt = sqatt_wait( &sqatt ) ;

          if( rslt == SQATT_RECEIVED )
          {
               printf( "sqatt_recv() ----------\n" ) ;
               buf_size = sizeof( data_buf ) ;
               memset( data_buf , 0x00 , buf_size ) ;
               rslt = sqatt_recv( &sqatt , buf_size , &data_size , data_buf ) ;
                                                                                
               printf( "sqatt_recv() rslt:%3d , data_size:%5d\n" ,
                        rslt , data_size ) ;
               printf( "data: %s\n" , data_buf ) ;

               rp_size = sizeof( rp_data ) ;
               memset( rp_data , 0x00 , rp_size ) ;
               strcpy( rp_data , "Reply data from socksv04.") ;
               rp_len = strlen( rp_data ) ;
                                                                                
               printf( "sqatt_reply() ----------\n" ) ;
               printf( "rp_len:%5d , rp_data: %s\n" , rp_len , rp_data ) ;
               rslt = sqatt_reply( &sqatt , rp_len , rp_data ) ;
               printf( "rslt:%3d\n" , rslt ) ;

          }
          else if( rslt == SQATT_USREV )
          {
               wsvfd = sqatt_get_usrfd( &sqatt ) ;
               printf( "User fd event notified.\n" ) ;
               printf( "svfd:%3d\n" , wsvfd ) ;

               /* Maybe wsvfd is equal to svfd. */
               /* But use wsvfd.                */
               clfd  = accept( wsvfd , ( struct sockaddr *)&cl_addr , &cllen ) ;
               printf( "clfd:%3d\n" , clfd ) ;

               read( clfd , &ch , 1 ) ;
               printf( "ch: 0x%02X\n" , ch ) ;
               write( clfd , &ch , 1 ) ;

               close( clfd ) ;
          }
          else
          {
               printf( "Error. sqatt_wait() rslt:%3d\n" , rslt ) ;
               break ;
          }
     }

     sqatt_del_usrfd( &sqatt , svfd ) ;
     sqatt_close( &sqatt ) ;

     printf( "Completed.\n" ) ;
}
